/* VpnMenuItem.c generated by valac 0.45.3, the Vala compiler
 * generated from VpnMenuItem.vala, do not modify */

/*
 * Copyright (c) 2017-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <NetworkManager.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#define NETWORK_TYPE_VPN_MENU_ITEM (network_vpn_menu_item_get_type ())
#define NETWORK_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem))
#define NETWORK_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItemClass))
#define NETWORK_IS_VPN_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_IS_VPN_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_VPN_MENU_ITEM))
#define NETWORK_VPN_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItemClass))

typedef struct _NetworkVpnMenuItem NetworkVpnMenuItem;
typedef struct _NetworkVpnMenuItemClass NetworkVpnMenuItemClass;
typedef struct _NetworkVpnMenuItemPrivate NetworkVpnMenuItemPrivate;
typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_DISCONNECTED_WIRED,
	NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTED_MOBILE_WEAK,
	NETWORK_STATE_CONNECTED_MOBILE_OK,
	NETWORK_STATE_CONNECTED_MOBILE_GOOD,
	NETWORK_STATE_CONNECTED_MOBILE_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;

#define NETWORK_TYPE_STATE (network_state_get_type ())
enum  {
	NETWORK_VPN_MENU_ITEM_0_PROPERTY,
	NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY,
	NETWORK_VPN_MENU_ITEM_ID_PROPERTY,
	NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY,
	NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY,
	NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_VPN_MENU_ITEM_NUM_SIGNALS
};
static guint network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkVpnMenuItem {
	GtkListBoxRow parent_instance;
	NetworkVpnMenuItemPrivate * priv;
};

struct _NetworkVpnMenuItemClass {
	GtkListBoxRowClass parent_class;
};

struct _NetworkVpnMenuItemPrivate {
	NMRemoteConnection* _connection;
	NetworkState _vpn_state;
	GtkRadioButton* _radio_button;
	GtkSpinner* spinner;
	GtkImage* error_img;
};

static gint NetworkVpnMenuItem_private_offset;
static gpointer network_vpn_menu_item_parent_class = NULL;
static GtkRadioButton* network_vpn_menu_item_blank_button;
static GtkRadioButton* network_vpn_menu_item_blank_button = NULL;

GType network_vpn_menu_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkVpnMenuItem, g_object_unref)
GType network_state_get_type (void) G_GNUC_CONST;
NetworkVpnMenuItem* network_vpn_menu_item_new (NMRemoteConnection* _connection);
NetworkVpnMenuItem* network_vpn_menu_item_construct (GType object_type,
                                                     NMRemoteConnection* _connection);
static void network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self,
                                           NMRemoteConnection* value);
NMRemoteConnection* network_vpn_menu_item_get_connection (NetworkVpnMenuItem* self);
static void network_vpn_menu_item_update (NetworkVpnMenuItem* self);
static void _network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                          gpointer self);
static void network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self,
                                             GtkRadioButton* value);
GtkRadioButton* network_vpn_menu_item_get_radio_button (NetworkVpnMenuItem* self);
static gboolean __lambda23_ (NetworkVpnMenuItem* self,
                      GtkWidget* b,
                      GdkEventButton* ev);
static gboolean ___lambda23__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void _network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
NetworkVpnMenuItem* network_vpn_menu_item_new_blank (void);
NetworkVpnMenuItem* network_vpn_menu_item_construct_blank (GType object_type);
static void network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self,
                                      GtkWidget* w);
NetworkState network_vpn_menu_item_get_vpn_state (NetworkVpnMenuItem* self);
static void network_vpn_menu_item_show_item (NetworkVpnMenuItem* self,
                                      GtkWidget* w);
void network_vpn_menu_item_set_active (NetworkVpnMenuItem* self,
                                       gboolean active);
const gchar* network_vpn_menu_item_get_id (NetworkVpnMenuItem* self);
void network_vpn_menu_item_set_vpn_state (NetworkVpnMenuItem* self,
                                          NetworkState value);
static void network_vpn_menu_item_finalize (GObject * obj);
static void _vala_network_vpn_menu_item_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_network_vpn_menu_item_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
network_vpn_menu_item_get_instance_private (NetworkVpnMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkVpnMenuItem_private_offset);
}

static void
_network_vpn_menu_item_update_nm_connection_changed (NMConnection* _sender,
                                                     gpointer self)
{
#line 36 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 164 "VpnMenuItem.c"
}

static gboolean
__lambda23_ (NetworkVpnMenuItem* self,
             GtkWidget* b,
             GdkEventButton* ev)
{
	gboolean result = FALSE;
#line 46 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 46 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 47 "../src/common/Widgets/VpnMenuItem.vala"
	g_signal_emit (self, network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL], 0);
#line 48 "../src/common/Widgets/VpnMenuItem.vala"
	result = FALSE;
#line 48 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 183 "VpnMenuItem.c"
}

static gboolean
___lambda23__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda23_ ((NetworkVpnMenuItem*) self, _sender, event);
#line 46 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 195 "VpnMenuItem.c"
}

static void
_network_vpn_menu_item_update_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 64 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update ((NetworkVpnMenuItem*) self);
#line 205 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_construct (GType object_type,
                                 NMRemoteConnection* _connection)
{
	NetworkVpnMenuItem * self = NULL;
	NMRemoteConnection* _tmp0_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkRadioButton* _tmp4_;
	GtkRadioButton* _tmp5_;
	GtkRadioButton* _tmp6_;
	GtkRadioButton* _tmp9_;
	GtkImage* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	GtkSpinner* _tmp15_;
	GtkSpinner* _tmp16_;
	GtkSpinner* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	GtkBox* _tmp20_;
	GtkRadioButton* _tmp21_;
	GtkBox* _tmp22_;
	GtkSpinner* _tmp23_;
	GtkBox* _tmp24_;
	GtkImage* _tmp25_;
	GtkRadioButton* _tmp26_;
	GtkBox* _tmp27_;
	GtkStyleContext* _tmp28_;
#line 34 "../src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 35 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_connection (self, _connection);
#line 36 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 36 "../src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((NMConnection*) _tmp0_, "changed", (GCallback) _network_vpn_menu_item_update_nm_connection_changed, self, 0);
#line 38 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 38 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp1_);
#line 38 "../src/common/Widgets/VpnMenuItem.vala"
	main_box = _tmp1_;
#line 39 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = main_box;
#line 39 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = main_box;
#line 39 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 6);
#line 39 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 6);
#line 41 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 41 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp4_);
#line 41 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = _tmp4_;
#line 41 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp5_);
#line 41 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp5_);
#line 42 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp6_ = network_vpn_menu_item_blank_button;
#line 42 "../src/common/Widgets/VpnMenuItem.vala"
	if (_tmp6_ != NULL) {
#line 277 "VpnMenuItem.c"
		GtkRadioButton* _tmp7_;
		GtkRadioButton* _tmp8_;
#line 43 "../src/common/Widgets/VpnMenuItem.vala"
		_tmp7_ = self->priv->_radio_button;
#line 43 "../src/common/Widgets/VpnMenuItem.vala"
		_tmp8_ = network_vpn_menu_item_blank_button;
#line 43 "../src/common/Widgets/VpnMenuItem.vala"
		gtk_radio_button_join_group (_tmp7_, _tmp8_);
#line 286 "VpnMenuItem.c"
	}
#line 46 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp9_ = self->priv->_radio_button;
#line 46 "../src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp9_, "button-release-event", (GCallback) ___lambda23__gtk_widget_button_release_event, self, 0);
#line 51 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 51 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp10_);
#line 51 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 51 "../src/common/Widgets/VpnMenuItem.vala"
	self->priv->error_img = _tmp10_;
#line 52 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp11_ = self->priv->error_img;
#line 52 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp11_, 6);
#line 53 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp12_ = self->priv->error_img;
#line 53 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp12_, _ ("This Virtual Private Network could not be connected to."));
#line 55 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp13_ = (GtkSpinner*) gtk_spinner_new ();
#line 55 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp13_);
#line 55 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 55 "../src/common/Widgets/VpnMenuItem.vala"
	self->priv->spinner = _tmp13_;
#line 56 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp14_ = self->priv->spinner;
#line 56 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_spinner_start (_tmp14_);
#line 57 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp15_ = self->priv->spinner;
#line 57 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, FALSE);
#line 58 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp16_ = self->priv->spinner;
#line 58 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp17_ = self->priv->spinner;
#line 58 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp18_ = gtk_widget_get_visible ((GtkWidget*) _tmp17_);
#line 58 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp19_ = _tmp18_;
#line 58 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp16_, !_tmp19_);
#line 60 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp20_ = main_box;
#line 60 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp21_ = self->priv->_radio_button;
#line 60 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp20_, (GtkWidget*) _tmp21_, TRUE, TRUE, (guint) 0);
#line 61 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp22_ = main_box;
#line 61 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp23_ = self->priv->spinner;
#line 61 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp22_, (GtkWidget*) _tmp23_, FALSE, FALSE, (guint) 0);
#line 62 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp24_ = main_box;
#line 62 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp25_ = self->priv->error_img;
#line 62 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_box_pack_start (_tmp24_, (GtkWidget*) _tmp25_, FALSE, FALSE, (guint) 0);
#line 64 "../src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::vpn_state", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 65 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp26_ = self->priv->_radio_button;
#line 65 "../src/common/Widgets/VpnMenuItem.vala"
	g_signal_connect_object ((GObject*) _tmp26_, "notify::active", (GCallback) _network_vpn_menu_item_update_g_object_notify, self, 0);
#line 67 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp27_ = main_box;
#line 67 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
#line 68 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 68 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_style_context_add_class (_tmp28_, "menuitem");
#line 70 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_update (self);
#line 34 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (main_box);
#line 34 "../src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 372 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_new (NMRemoteConnection* _connection)
{
#line 34 "../src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct (NETWORK_TYPE_VPN_MENU_ITEM, _connection);
#line 380 "VpnMenuItem.c"
}

/**
    * Only used for an item which is not displayed: hacky way to have no radio button selected.
    **/
NetworkVpnMenuItem*
network_vpn_menu_item_construct_blank (GType object_type)
{
	NetworkVpnMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
#line 76 "../src/common/Widgets/VpnMenuItem.vala"
	self = (NetworkVpnMenuItem*) g_object_new (object_type, NULL);
#line 77 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 77 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 77 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_set_radio_button (self, _tmp1_);
#line 77 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (_tmp1_);
#line 78 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = self->priv->_radio_button;
#line 78 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_blank_button = _tmp2_;
#line 76 "../src/common/Widgets/VpnMenuItem.vala"
	return self;
#line 411 "VpnMenuItem.c"
}

NetworkVpnMenuItem*
network_vpn_menu_item_new_blank (void)
{
#line 76 "../src/common/Widgets/VpnMenuItem.vala"
	return network_vpn_menu_item_construct_blank (NETWORK_TYPE_VPN_MENU_ITEM);
#line 419 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_update (NetworkVpnMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	NMRemoteConnection* _tmp1_;
	const gchar* _tmp2_;
	GtkImage* _tmp3_;
	GtkSpinner* _tmp4_;
	NetworkState _tmp5_;
#line 81 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 82 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = self->priv->_connection;
#line 82 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp2_ = nm_connection_get_id ((NMConnection*) _tmp1_);
#line 82 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp2_);
#line 83 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp3_ = self->priv->error_img;
#line 83 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp3_);
#line 84 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp4_ = self->priv->spinner;
#line 84 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_hide_item (self, (GtkWidget*) _tmp4_);
#line 86 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp5_ = self->priv->_vpn_state;
#line 86 "../src/common/Widgets/VpnMenuItem.vala"
	switch (_tmp5_) {
#line 86 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_FAILED_VPN:
#line 455 "VpnMenuItem.c"
		{
			GtkImage* _tmp6_;
#line 88 "../src/common/Widgets/VpnMenuItem.vala"
			_tmp6_ = self->priv->error_img;
#line 88 "../src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp6_);
#line 89 "../src/common/Widgets/VpnMenuItem.vala"
			break;
#line 464 "VpnMenuItem.c"
		}
#line 86 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_STATE_CONNECTING_VPN:
#line 468 "VpnMenuItem.c"
		{
			GtkSpinner* _tmp7_;
			GtkRadioButton* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 91 "../src/common/Widgets/VpnMenuItem.vala"
			_tmp7_ = self->priv->spinner;
#line 91 "../src/common/Widgets/VpnMenuItem.vala"
			network_vpn_menu_item_show_item (self, (GtkWidget*) _tmp7_);
#line 92 "../src/common/Widgets/VpnMenuItem.vala"
			_tmp8_ = self->priv->_radio_button;
#line 92 "../src/common/Widgets/VpnMenuItem.vala"
			_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
#line 92 "../src/common/Widgets/VpnMenuItem.vala"
			_tmp10_ = _tmp9_;
#line 92 "../src/common/Widgets/VpnMenuItem.vala"
			if (!_tmp10_) {
#line 93 "../src/common/Widgets/VpnMenuItem.vala"
				g_critical ("VpnMenuItem.vala:93: An VPN is being connected but not active.");
#line 488 "VpnMenuItem.c"
			}
#line 95 "../src/common/Widgets/VpnMenuItem.vala"
			break;
#line 492 "VpnMenuItem.c"
		}
		default:
#line 86 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 497 "VpnMenuItem.c"
	}
}

void
network_vpn_menu_item_set_active (NetworkVpnMenuItem* self,
                                  gboolean active)
{
	GtkRadioButton* _tmp0_;
#line 99 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 100 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, active);
#line 512 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_show_item (NetworkVpnMenuItem* self,
                                 GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 103 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 104 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (w, TRUE);
#line 105 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 105 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 105 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (w, _tmp1_);
#line 533 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_hide_item (NetworkVpnMenuItem* self,
                                 GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 108 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 109 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_visible (w, FALSE);
#line 110 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 110 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 111 "../src/common/Widgets/VpnMenuItem.vala"
	gtk_widget_hide (w);
#line 556 "VpnMenuItem.c"
}

NMRemoteConnection*
network_vpn_menu_item_get_connection (NetworkVpnMenuItem* self)
{
	NMRemoteConnection* result;
	NMRemoteConnection* _tmp0_;
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 572 "VpnMenuItem.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 580 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_set_connection (NetworkVpnMenuItem* self,
                                      NMRemoteConnection* value)
{
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	if (network_vpn_menu_item_get_connection (self) != value) {
#line 591 "VpnMenuItem.c"
		NMRemoteConnection* _tmp0_;
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_connection);
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
		self->priv->_connection = _tmp0_;
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY]);
#line 601 "VpnMenuItem.c"
	}
}

const gchar*
network_vpn_menu_item_get_id (NetworkVpnMenuItem* self)
{
	const gchar* result;
	NMRemoteConnection* _tmp0_;
	const gchar* _tmp1_;
#line 24 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_connection;
#line 25 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp1_ = nm_connection_get_id ((NMConnection*) _tmp0_);
#line 25 "../src/common/Widgets/VpnMenuItem.vala"
	result = _tmp1_;
#line 25 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 621 "VpnMenuItem.c"
}

NetworkState
network_vpn_menu_item_get_vpn_state (NetworkVpnMenuItem* self)
{
	NetworkState result;
	NetworkState _tmp0_;
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_vpn_state;
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 637 "VpnMenuItem.c"
}

void
network_vpn_menu_item_set_vpn_state (NetworkVpnMenuItem* self,
                                     NetworkState value)
{
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	if (network_vpn_menu_item_get_vpn_state (self) != value) {
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
		self->priv->_vpn_state = value;
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY]);
#line 652 "VpnMenuItem.c"
	}
}

GtkRadioButton*
network_vpn_menu_item_get_radio_button (NetworkVpnMenuItem* self)
{
	GtkRadioButton* result;
	GtkRadioButton* _tmp0_;
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	_tmp0_ = self->priv->_radio_button;
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	result = _tmp0_;
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	return result;
#line 669 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_set_radio_button (NetworkVpnMenuItem* self,
                                        GtkRadioButton* value)
{
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	if (network_vpn_menu_item_get_radio_button (self) != value) {
#line 680 "VpnMenuItem.c"
		GtkRadioButton* _tmp0_;
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
		_g_object_unref0 (self->priv->_radio_button);
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
		self->priv->_radio_button = _tmp0_;
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY]);
#line 690 "VpnMenuItem.c"
	}
}

static void
network_vpn_menu_item_class_init (NetworkVpnMenuItemClass * klass,
                                  gpointer klass_data)
{
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkVpnMenuItem_private_offset);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_vpn_menu_item_get_property;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_vpn_menu_item_set_property;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_vpn_menu_item_finalize;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY] = g_param_spec_object ("connection", "connection", "connection", nm_remote_connection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_ID_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY] = g_param_spec_enum ("vpn-state", "vpn-state", "vpn-state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY, network_vpn_menu_item_properties[NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY] = g_param_spec_object ("radio-button", "radio-button", "radio-button", gtk_radio_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	network_vpn_menu_item_signals[NETWORK_VPN_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_VPN_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 718 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_instance_init (NetworkVpnMenuItem * self,
                                     gpointer klass)
{
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	self->priv = network_vpn_menu_item_get_instance_private (self);
#line 28 "../src/common/Widgets/VpnMenuItem.vala"
	self->priv->_vpn_state = NETWORK_STATE_DISCONNECTED;
#line 729 "VpnMenuItem.c"
}

static void
network_vpn_menu_item_finalize (GObject * obj)
{
	NetworkVpnMenuItem * self;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 22 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_connection);
#line 30 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->_radio_button);
#line 31 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 32 "../src/common/Widgets/VpnMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	G_OBJECT_CLASS (network_vpn_menu_item_parent_class)->finalize (obj);
#line 748 "VpnMenuItem.c"
}

GType
network_vpn_menu_item_get_type (void)
{
	static volatile gsize network_vpn_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_vpn_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkVpnMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_vpn_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkVpnMenuItem), 0, (GInstanceInitFunc) network_vpn_menu_item_instance_init, NULL };
		GType network_vpn_menu_item_type_id;
		network_vpn_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkVpnMenuItem", &g_define_type_info, 0);
		NetworkVpnMenuItem_private_offset = g_type_add_instance_private (network_vpn_menu_item_type_id, sizeof (NetworkVpnMenuItemPrivate));
		g_once_init_leave (&network_vpn_menu_item_type_id__volatile, network_vpn_menu_item_type_id);
	}
	return network_vpn_menu_item_type_id__volatile;
}

static void
_vala_network_vpn_menu_item_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_connection (self));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_ID_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		g_value_set_string (value, network_vpn_menu_item_get_id (self));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		g_value_set_enum (value, network_vpn_menu_item_get_vpn_state (self));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		g_value_set_object (value, network_vpn_menu_item_get_radio_button (self));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 799 "VpnMenuItem.c"
		default:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 805 "VpnMenuItem.c"
	}
}

static void
_vala_network_vpn_menu_item_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	NetworkVpnMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_VPN_MENU_ITEM, NetworkVpnMenuItem);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
	switch (property_id) {
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_CONNECTION_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_connection (self, g_value_get_object (value));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_VPN_STATE_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_vpn_state (self, g_value_get_enum (value));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		case NETWORK_VPN_MENU_ITEM_RADIO_BUTTON_PROPERTY:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		network_vpn_menu_item_set_radio_button (self, g_value_get_object (value));
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 837 "VpnMenuItem.c"
		default:
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/common/Widgets/VpnMenuItem.vala"
		break;
#line 843 "VpnMenuItem.c"
	}
}

