/* rfkill.c generated by valac 0.45.3, the Vala compiler
 * generated from rfkill.vala, do not modify */

/*
 * Copyright (C) 2012 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <unistd.h>
#include <gobject/gvaluecollector.h>
#include <fcntl.h>
#include <sys/types.h>

typedef enum  {
	RF_KILL_DEVICE_TYPE_ALL = 0,
	RF_KILL_DEVICE_TYPE_WLAN,
	RF_KILL_DEVICE_TYPE_BLUETOOTH,
	RF_KILL_DEVICE_TYPE_UWB,
	RF_KILL_DEVICE_TYPE_WIMAX,
	RF_KILL_DEVICE_TYPE_WMAN
} RFKillDeviceType;

#define TYPE_RF_KILL_DEVICE_TYPE (rf_kill_device_type_get_type ())

#define TYPE_RF_KILL_DEVICE (rf_kill_device_get_type ())
#define RF_KILL_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RF_KILL_DEVICE, RFKillDevice))
#define RF_KILL_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RF_KILL_DEVICE, RFKillDeviceClass))
#define IS_RF_KILL_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RF_KILL_DEVICE))
#define IS_RF_KILL_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RF_KILL_DEVICE))
#define RF_KILL_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RF_KILL_DEVICE, RFKillDeviceClass))

typedef struct _RFKillDevice RFKillDevice;
typedef struct _RFKillDeviceClass RFKillDeviceClass;
typedef struct _RFKillDevicePrivate RFKillDevicePrivate;

#define TYPE_RF_KILL_MANAGER (rf_kill_manager_get_type ())
#define RF_KILL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RF_KILL_MANAGER, RFKillManager))
#define RF_KILL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RF_KILL_MANAGER, RFKillManagerClass))
#define IS_RF_KILL_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RF_KILL_MANAGER))
#define IS_RF_KILL_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RF_KILL_MANAGER))
#define RF_KILL_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RF_KILL_MANAGER, RFKillManagerClass))

typedef struct _RFKillManager RFKillManager;
typedef struct _RFKillManagerClass RFKillManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_RF_KILL_EVENT (rf_kill_event_get_type ())
typedef struct _RFKillEvent RFKillEvent;
typedef enum  {
	RF_KILL_OPERATION_ADD = 0,
	RF_KILL_OPERATION_DELETE,
	RF_KILL_OPERATION_CHANGE,
	RF_KILL_OPERATION_CHANGE_ALL
} RFKillOperation;

#define TYPE_RF_KILL_OPERATION (rf_kill_operation_get_type ())
typedef struct _RFKillManagerPrivate RFKillManagerPrivate;
typedef struct _ParamSpecRFKillDevice ParamSpecRFKillDevice;
enum  {
	RF_KILL_DEVICE_CHANGED_SIGNAL,
	RF_KILL_DEVICE_NUM_SIGNALS
};
static guint rf_kill_device_signals[RF_KILL_DEVICE_NUM_SIGNALS] = {0};
enum  {
	RF_KILL_MANAGER_0_PROPERTY,
	RF_KILL_MANAGER_NUM_PROPERTIES
};
static GParamSpec* rf_kill_manager_properties[RF_KILL_MANAGER_NUM_PROPERTIES];
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _rf_kill_device_unref0(var) ((var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL)))
enum  {
	RF_KILL_MANAGER_DEVICE_ADDED_SIGNAL,
	RF_KILL_MANAGER_DEVICE_CHANGED_SIGNAL,
	RF_KILL_MANAGER_DEVICE_DELETED_SIGNAL,
	RF_KILL_MANAGER_NUM_SIGNALS
};
static guint rf_kill_manager_signals[RF_KILL_MANAGER_NUM_SIGNALS] = {0};

struct _RFKillDevice {
	GTypeInstance parent_instance;
	volatile int ref_count;
	RFKillDevicePrivate * priv;
	RFKillManager* manager;
	guint32 idx;
	RFKillDeviceType _device_type;
	gboolean _software_lock;
	gboolean _hardware_lock;
};

struct _RFKillDeviceClass {
	GTypeClass parent_class;
	void (*finalize) (RFKillDevice *self);
};

struct _RFKillEvent {
	guint32 idx;
	guint8 type;
	guint8 op;
	guint8 soft;
	guint8 hard;
};

struct _RFKillManager {
	GObject parent_instance;
	RFKillManagerPrivate * priv;
	gint fd;
};

struct _RFKillManagerClass {
	GObjectClass parent_class;
};

struct _ParamSpecRFKillDevice {
	GParamSpec parent_instance;
};

struct _RFKillManagerPrivate {
	GList* _devices;
};

static gpointer rf_kill_device_parent_class = NULL;
static gint RFKillManager_private_offset;
static gpointer rf_kill_manager_parent_class = NULL;

GType rf_kill_device_type_get_type (void) G_GNUC_CONST;
gpointer rf_kill_device_ref (gpointer instance);
void rf_kill_device_unref (gpointer instance);
GParamSpec* param_spec_rf_kill_device (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_rf_kill_device (GValue* value,
                               gpointer v_object);
void value_take_rf_kill_device (GValue* value,
                                gpointer v_object);
gpointer value_get_rf_kill_device (const GValue* value);
GType rf_kill_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RFKillDevice, rf_kill_device_unref)
GType rf_kill_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RFKillManager, g_object_unref)
RFKillDevice* rf_kill_device_new (RFKillManager* manager,
                                  guint32 idx,
                                  RFKillDeviceType device_type,
                                  gboolean software_lock,
                                  gboolean hardware_lock);
RFKillDevice* rf_kill_device_construct (GType object_type,
                                        RFKillManager* manager,
                                        guint32 idx,
                                        RFKillDeviceType device_type,
                                        gboolean software_lock,
                                        gboolean hardware_lock);
gboolean rf_kill_device_get_software_lock (RFKillDevice* self);
void rf_kill_device_set_software_lock (RFKillDevice* self,
                                       gboolean value);
GType rf_kill_event_get_type (void) G_GNUC_CONST;
RFKillEvent* rf_kill_event_dup (const RFKillEvent* self);
void rf_kill_event_free (RFKillEvent* self);
GType rf_kill_operation_get_type (void) G_GNUC_CONST;
gboolean rf_kill_device_get_hardware_lock (RFKillDevice* self);
RFKillDeviceType rf_kill_device_get_device_type (RFKillDevice* self);
static void rf_kill_device_finalize (RFKillDevice * obj);
static void _rf_kill_device_unref0_ (gpointer var);
static inline void _g_list_free__rf_kill_device_unref0_ (GList* self);
RFKillManager* rf_kill_manager_new (void);
RFKillManager* rf_kill_manager_construct (GType object_type);
void rf_kill_manager_open (RFKillManager* self);
static gboolean rf_kill_manager_read_event (RFKillManager* self);
static gboolean __lambda6_ (RFKillManager* self);
static gboolean ___lambda6__gio_func (GIOChannel* source,
                               GIOCondition condition,
                               gpointer self);
GList* rf_kill_manager_get_devices (RFKillManager* self);
void rf_kill_manager_set_software_lock (RFKillManager* self,
                                        RFKillDeviceType type,
                                        gboolean lock_enabled);
static RFKillDevice* rf_kill_manager_get_device (RFKillManager* self,
                                          guint32 idx);
static void g_cclosure_user_marshal_VOID__RF_KILL_DEVICE (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void rf_kill_manager_finalize (GObject * obj);

GType
rf_kill_device_type_get_type (void)
{
	static volatile gsize rf_kill_device_type_type_id__volatile = 0;
	if (g_once_init_enter (&rf_kill_device_type_type_id__volatile)) {
		static const GEnumValue values[] = {{RF_KILL_DEVICE_TYPE_ALL, "RF_KILL_DEVICE_TYPE_ALL", "all"}, {RF_KILL_DEVICE_TYPE_WLAN, "RF_KILL_DEVICE_TYPE_WLAN", "wlan"}, {RF_KILL_DEVICE_TYPE_BLUETOOTH, "RF_KILL_DEVICE_TYPE_BLUETOOTH", "bluetooth"}, {RF_KILL_DEVICE_TYPE_UWB, "RF_KILL_DEVICE_TYPE_UWB", "uwb"}, {RF_KILL_DEVICE_TYPE_WIMAX, "RF_KILL_DEVICE_TYPE_WIMAX", "wimax"}, {RF_KILL_DEVICE_TYPE_WMAN, "RF_KILL_DEVICE_TYPE_WMAN", "wman"}, {0, NULL, NULL}};
		GType rf_kill_device_type_type_id;
		rf_kill_device_type_type_id = g_enum_register_static ("RFKillDeviceType", values);
		g_once_init_leave (&rf_kill_device_type_type_id__volatile, rf_kill_device_type_type_id);
	}
	return rf_kill_device_type_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/common/rfkill.vala"
	return self ? g_object_ref (self) : NULL;
#line 215 "rfkill.c"
}

RFKillDevice*
rf_kill_device_construct (GType object_type,
                          RFKillManager* manager,
                          guint32 idx,
                          RFKillDeviceType device_type,
                          gboolean software_lock,
                          gboolean hardware_lock)
{
	RFKillDevice* self = NULL;
	RFKillManager* _tmp0_;
#line 46 "../src/common/rfkill.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 46 "../src/common/rfkill.vala"
	self = (RFKillDevice*) g_type_create_instance (object_type);
#line 47 "../src/common/rfkill.vala"
	_tmp0_ = _g_object_ref0 (manager);
#line 47 "../src/common/rfkill.vala"
	_g_object_unref0 (self->manager);
#line 47 "../src/common/rfkill.vala"
	self->manager = _tmp0_;
#line 48 "../src/common/rfkill.vala"
	self->idx = idx;
#line 49 "../src/common/rfkill.vala"
	self->_device_type = device_type;
#line 50 "../src/common/rfkill.vala"
	self->_software_lock = software_lock;
#line 51 "../src/common/rfkill.vala"
	self->_hardware_lock = hardware_lock;
#line 46 "../src/common/rfkill.vala"
	return self;
#line 248 "rfkill.c"
}

RFKillDevice*
rf_kill_device_new (RFKillManager* manager,
                    guint32 idx,
                    RFKillDeviceType device_type,
                    gboolean software_lock,
                    gboolean hardware_lock)
{
#line 46 "../src/common/rfkill.vala"
	return rf_kill_device_construct (TYPE_RF_KILL_DEVICE, manager, idx, device_type, software_lock, hardware_lock);
#line 260 "rfkill.c"
}

gboolean
rf_kill_device_get_software_lock (RFKillDevice* self)
{
	gboolean result;
#line 25 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/common/rfkill.vala"
	result = self->_software_lock;
#line 25 "../src/common/rfkill.vala"
	return result;
#line 273 "rfkill.c"
}

void
rf_kill_device_set_software_lock (RFKillDevice* self,
                                  gboolean value)
{
	RFKillEvent event = {0};
	gint _tmp0_ = 0;
	RFKillManager* _tmp1_;
#line 26 "../src/common/rfkill.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/common/rfkill.vala"
	memset (&event, 0, sizeof (RFKillEvent));
#line 28 "../src/common/rfkill.vala"
	event.idx = self->idx;
#line 29 "../src/common/rfkill.vala"
	event.op = (guint8) RF_KILL_OPERATION_CHANGE;
#line 30 "../src/common/rfkill.vala"
	if (value) {
#line 30 "../src/common/rfkill.vala"
		_tmp0_ = 1;
#line 295 "rfkill.c"
	} else {
#line 30 "../src/common/rfkill.vala"
		_tmp0_ = 0;
#line 299 "rfkill.c"
	}
#line 30 "../src/common/rfkill.vala"
	event.soft = (guint8) _tmp0_;
#line 31 "../src/common/rfkill.vala"
	_tmp1_ = self->manager;
#line 31 "../src/common/rfkill.vala"
	if (write (_tmp1_->fd, &event, (gsize) 8) != ((gssize) 8)) {
#line 32 "../src/common/rfkill.vala"
		return;
#line 309 "rfkill.c"
	}
}

gboolean
rf_kill_device_get_hardware_lock (RFKillDevice* self)
{
	gboolean result;
#line 36 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/common/rfkill.vala"
	result = self->_hardware_lock;
#line 36 "../src/common/rfkill.vala"
	return result;
#line 323 "rfkill.c"
}

RFKillDeviceType
rf_kill_device_get_device_type (RFKillDevice* self)
{
	RFKillDeviceType result;
	RFKillDeviceType _tmp0_;
#line 38 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/common/rfkill.vala"
	_tmp0_ = self->_device_type;
#line 38 "../src/common/rfkill.vala"
	result = _tmp0_;
#line 38 "../src/common/rfkill.vala"
	return result;
#line 339 "rfkill.c"
}

static void
value_rf_kill_device_init (GValue* value)
{
#line 21 "../src/common/rfkill.vala"
	value->data[0].v_pointer = NULL;
#line 347 "rfkill.c"
}

static void
value_rf_kill_device_free_value (GValue* value)
{
#line 21 "../src/common/rfkill.vala"
	if (value->data[0].v_pointer) {
#line 21 "../src/common/rfkill.vala"
		rf_kill_device_unref (value->data[0].v_pointer);
#line 357 "rfkill.c"
	}
}

static void
value_rf_kill_device_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 21 "../src/common/rfkill.vala"
	if (src_value->data[0].v_pointer) {
#line 21 "../src/common/rfkill.vala"
		dest_value->data[0].v_pointer = rf_kill_device_ref (src_value->data[0].v_pointer);
#line 369 "rfkill.c"
	} else {
#line 21 "../src/common/rfkill.vala"
		dest_value->data[0].v_pointer = NULL;
#line 373 "rfkill.c"
	}
}

static gpointer
value_rf_kill_device_peek_pointer (const GValue* value)
{
#line 21 "../src/common/rfkill.vala"
	return value->data[0].v_pointer;
#line 382 "rfkill.c"
}

static gchar*
value_rf_kill_device_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 21 "../src/common/rfkill.vala"
	if (collect_values[0].v_pointer) {
#line 393 "rfkill.c"
		RFKillDevice * object;
		object = collect_values[0].v_pointer;
#line 21 "../src/common/rfkill.vala"
		if (object->parent_instance.g_class == NULL) {
#line 21 "../src/common/rfkill.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 400 "rfkill.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 21 "../src/common/rfkill.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 404 "rfkill.c"
		}
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = rf_kill_device_ref (object);
#line 408 "rfkill.c"
	} else {
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = NULL;
#line 412 "rfkill.c"
	}
#line 21 "../src/common/rfkill.vala"
	return NULL;
#line 416 "rfkill.c"
}

static gchar*
value_rf_kill_device_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	RFKillDevice ** object_p;
	object_p = collect_values[0].v_pointer;
#line 21 "../src/common/rfkill.vala"
	if (!object_p) {
#line 21 "../src/common/rfkill.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 431 "rfkill.c"
	}
#line 21 "../src/common/rfkill.vala"
	if (!value->data[0].v_pointer) {
#line 21 "../src/common/rfkill.vala"
		*object_p = NULL;
#line 437 "rfkill.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 21 "../src/common/rfkill.vala"
		*object_p = value->data[0].v_pointer;
#line 441 "rfkill.c"
	} else {
#line 21 "../src/common/rfkill.vala"
		*object_p = rf_kill_device_ref (value->data[0].v_pointer);
#line 445 "rfkill.c"
	}
#line 21 "../src/common/rfkill.vala"
	return NULL;
#line 449 "rfkill.c"
}

GParamSpec*
param_spec_rf_kill_device (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecRFKillDevice* spec;
#line 21 "../src/common/rfkill.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_RF_KILL_DEVICE), NULL);
#line 21 "../src/common/rfkill.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 21 "../src/common/rfkill.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 21 "../src/common/rfkill.vala"
	return G_PARAM_SPEC (spec);
#line 468 "rfkill.c"
}

gpointer
value_get_rf_kill_device (const GValue* value)
{
#line 21 "../src/common/rfkill.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RF_KILL_DEVICE), NULL);
#line 21 "../src/common/rfkill.vala"
	return value->data[0].v_pointer;
#line 478 "rfkill.c"
}

void
value_set_rf_kill_device (GValue* value,
                          gpointer v_object)
{
	RFKillDevice * old;
#line 21 "../src/common/rfkill.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RF_KILL_DEVICE));
#line 21 "../src/common/rfkill.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/common/rfkill.vala"
	if (v_object) {
#line 21 "../src/common/rfkill.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RF_KILL_DEVICE));
#line 21 "../src/common/rfkill.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = v_object;
#line 21 "../src/common/rfkill.vala"
		rf_kill_device_ref (value->data[0].v_pointer);
#line 500 "rfkill.c"
	} else {
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = NULL;
#line 504 "rfkill.c"
	}
#line 21 "../src/common/rfkill.vala"
	if (old) {
#line 21 "../src/common/rfkill.vala"
		rf_kill_device_unref (old);
#line 510 "rfkill.c"
	}
}

void
value_take_rf_kill_device (GValue* value,
                           gpointer v_object)
{
	RFKillDevice * old;
#line 21 "../src/common/rfkill.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_RF_KILL_DEVICE));
#line 21 "../src/common/rfkill.vala"
	old = value->data[0].v_pointer;
#line 21 "../src/common/rfkill.vala"
	if (v_object) {
#line 21 "../src/common/rfkill.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_RF_KILL_DEVICE));
#line 21 "../src/common/rfkill.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = v_object;
#line 531 "rfkill.c"
	} else {
#line 21 "../src/common/rfkill.vala"
		value->data[0].v_pointer = NULL;
#line 535 "rfkill.c"
	}
#line 21 "../src/common/rfkill.vala"
	if (old) {
#line 21 "../src/common/rfkill.vala"
		rf_kill_device_unref (old);
#line 541 "rfkill.c"
	}
}

static void
rf_kill_device_class_init (RFKillDeviceClass * klass,
                           gpointer klass_data)
{
#line 21 "../src/common/rfkill.vala"
	rf_kill_device_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/common/rfkill.vala"
	((RFKillDeviceClass *) klass)->finalize = rf_kill_device_finalize;
#line 21 "../src/common/rfkill.vala"
	rf_kill_device_signals[RF_KILL_DEVICE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_RF_KILL_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 555 "rfkill.c"
}

static void
rf_kill_device_instance_init (RFKillDevice * self,
                              gpointer klass)
{
#line 21 "../src/common/rfkill.vala"
	self->ref_count = 1;
#line 564 "rfkill.c"
}

static void
rf_kill_device_finalize (RFKillDevice * obj)
{
	RFKillDevice * self;
#line 21 "../src/common/rfkill.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RF_KILL_DEVICE, RFKillDevice);
#line 21 "../src/common/rfkill.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/common/rfkill.vala"
	_g_object_unref0 (self->manager);
#line 577 "rfkill.c"
}

GType
rf_kill_device_get_type (void)
{
	static volatile gsize rf_kill_device_type_id__volatile = 0;
	if (g_once_init_enter (&rf_kill_device_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_rf_kill_device_init, value_rf_kill_device_free_value, value_rf_kill_device_copy_value, value_rf_kill_device_peek_pointer, "p", value_rf_kill_device_collect_value, "p", value_rf_kill_device_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (RFKillDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rf_kill_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RFKillDevice), 0, (GInstanceInitFunc) rf_kill_device_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType rf_kill_device_type_id;
		rf_kill_device_type_id = g_type_register_fundamental (g_type_fundamental_next (), "RFKillDevice", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&rf_kill_device_type_id__volatile, rf_kill_device_type_id);
	}
	return rf_kill_device_type_id__volatile;
}

gpointer
rf_kill_device_ref (gpointer instance)
{
	RFKillDevice * self;
	self = instance;
#line 21 "../src/common/rfkill.vala"
	g_atomic_int_inc (&self->ref_count);
#line 21 "../src/common/rfkill.vala"
	return instance;
#line 604 "rfkill.c"
}

void
rf_kill_device_unref (gpointer instance)
{
	RFKillDevice * self;
	self = instance;
#line 21 "../src/common/rfkill.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 21 "../src/common/rfkill.vala"
		RF_KILL_DEVICE_GET_CLASS (self)->finalize (self);
#line 21 "../src/common/rfkill.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 618 "rfkill.c"
	}
}

static inline gpointer
rf_kill_manager_get_instance_private (RFKillManager* self)
{
	return G_STRUCT_MEMBER_P (self, RFKillManager_private_offset);
}

static void
_rf_kill_device_unref0_ (gpointer var)
{
#line 93 "../src/common/rfkill.vala"
	(var == NULL) ? NULL : (var = (rf_kill_device_unref (var), NULL));
#line 633 "rfkill.c"
}

static inline void
_g_list_free__rf_kill_device_unref0_ (GList* self)
{
#line 93 "../src/common/rfkill.vala"
	g_list_free_full (self, (GDestroyNotify) _rf_kill_device_unref0_);
#line 641 "rfkill.c"
}

RFKillManager*
rf_kill_manager_construct (GType object_type)
{
	RFKillManager * self = NULL;
#line 60 "../src/common/rfkill.vala"
	self = (RFKillManager*) g_object_new (object_type, NULL);
#line 61 "../src/common/rfkill.vala"
	(self->priv->_devices == NULL) ? NULL : (self->priv->_devices = (_g_list_free__rf_kill_device_unref0_ (self->priv->_devices), NULL));
#line 61 "../src/common/rfkill.vala"
	self->priv->_devices = NULL;
#line 60 "../src/common/rfkill.vala"
	return self;
#line 656 "rfkill.c"
}

RFKillManager*
rf_kill_manager_new (void)
{
#line 60 "../src/common/rfkill.vala"
	return rf_kill_manager_construct (TYPE_RF_KILL_MANAGER);
#line 664 "rfkill.c"
}

static gboolean
__lambda6_ (RFKillManager* self)
{
	gboolean result = FALSE;
#line 73 "../src/common/rfkill.vala"
	result = rf_kill_manager_read_event (self);
#line 73 "../src/common/rfkill.vala"
	return result;
#line 675 "rfkill.c"
}

static gboolean
___lambda6__gio_func (GIOChannel* source,
                      GIOCondition condition,
                      gpointer self)
{
	gboolean result;
	result = __lambda6_ ((RFKillManager*) self);
#line 73 "../src/common/rfkill.vala"
	return result;
#line 687 "rfkill.c"
}

void
rf_kill_manager_open (RFKillManager* self)
{
	GIOChannel* channel = NULL;
	GIOChannel* _tmp0_;
#line 64 "../src/common/rfkill.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/common/rfkill.vala"
	self->fd = open ("/dev/rfkill", O_RDWR, (mode_t) 0);
#line 66 "../src/common/rfkill.vala"
	fcntl (self->fd, F_SETFL, O_NONBLOCK, NULL);
#line 69 "../src/common/rfkill.vala"
	while (TRUE) {
#line 69 "../src/common/rfkill.vala"
		if (!rf_kill_manager_read_event (self)) {
#line 69 "../src/common/rfkill.vala"
			break;
#line 707 "rfkill.c"
		}
	}
#line 72 "../src/common/rfkill.vala"
	_tmp0_ = g_io_channel_unix_new (self->fd);
#line 72 "../src/common/rfkill.vala"
	channel = _tmp0_;
#line 73 "../src/common/rfkill.vala"
	g_io_add_watch (channel, (G_IO_IN | G_IO_HUP) | G_IO_ERR, ___lambda6__gio_func, self);
#line 64 "../src/common/rfkill.vala"
	_g_io_channel_unref0 (channel);
#line 718 "rfkill.c"
}

static gpointer
_rf_kill_device_ref0 (gpointer self)
{
#line 78 "../src/common/rfkill.vala"
	return self ? rf_kill_device_ref (self) : NULL;
#line 726 "rfkill.c"
}

GList*
rf_kill_manager_get_devices (RFKillManager* self)
{
	GList* result = NULL;
	GList* devices = NULL;
	GList* _tmp0_;
#line 76 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/common/rfkill.vala"
	devices = NULL;
#line 78 "../src/common/rfkill.vala"
	_tmp0_ = self->priv->_devices;
#line 741 "rfkill.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 78 "../src/common/rfkill.vala"
		device_collection = _tmp0_;
#line 78 "../src/common/rfkill.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 749 "rfkill.c"
			RFKillDevice* _tmp1_;
			RFKillDevice* device = NULL;
#line 78 "../src/common/rfkill.vala"
			_tmp1_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
#line 78 "../src/common/rfkill.vala"
			device = _tmp1_;
#line 756 "rfkill.c"
			{
				RFKillDevice* _tmp2_;
				RFKillDevice* _tmp3_;
#line 79 "../src/common/rfkill.vala"
				_tmp2_ = device;
#line 79 "../src/common/rfkill.vala"
				_tmp3_ = _rf_kill_device_ref0 (_tmp2_);
#line 79 "../src/common/rfkill.vala"
				devices = g_list_append (devices, _tmp3_);
#line 78 "../src/common/rfkill.vala"
				_rf_kill_device_unref0 (device);
#line 768 "rfkill.c"
			}
		}
	}
#line 80 "../src/common/rfkill.vala"
	result = devices;
#line 80 "../src/common/rfkill.vala"
	return result;
#line 776 "rfkill.c"
}

void
rf_kill_manager_set_software_lock (RFKillManager* self,
                                   RFKillDeviceType type,
                                   gboolean lock_enabled)
{
	RFKillEvent event = {0};
	gint _tmp0_ = 0;
#line 83 "../src/common/rfkill.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/common/rfkill.vala"
	memset (&event, 0, sizeof (RFKillEvent));
#line 85 "../src/common/rfkill.vala"
	event.type = (guint8) type;
#line 86 "../src/common/rfkill.vala"
	event.op = (guint8) RF_KILL_OPERATION_CHANGE_ALL;
#line 87 "../src/common/rfkill.vala"
	if (lock_enabled) {
#line 87 "../src/common/rfkill.vala"
		_tmp0_ = 1;
#line 798 "rfkill.c"
	} else {
#line 87 "../src/common/rfkill.vala"
		_tmp0_ = 0;
#line 802 "rfkill.c"
	}
#line 87 "../src/common/rfkill.vala"
	event.soft = (guint8) _tmp0_;
#line 88 "../src/common/rfkill.vala"
	if (write (self->fd, &event, (gsize) 8) != ((gssize) 8)) {
#line 89 "../src/common/rfkill.vala"
		return;
#line 810 "rfkill.c"
	}
}

static gboolean
rf_kill_manager_read_event (RFKillManager* self)
{
	gboolean result = FALSE;
	RFKillEvent event = {0};
	RFKillEvent _tmp0_;
#line 95 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/common/rfkill.vala"
	memset (&event, 0, sizeof (RFKillEvent));
#line 97 "../src/common/rfkill.vala"
	if (read (self->fd, &event, (gsize) 8) != ((gssize) 8)) {
#line 98 "../src/common/rfkill.vala"
		result = FALSE;
#line 98 "../src/common/rfkill.vala"
		return result;
#line 830 "rfkill.c"
	}
#line 100 "../src/common/rfkill.vala"
	_tmp0_ = event;
#line 100 "../src/common/rfkill.vala"
	switch (_tmp0_.op) {
#line 100 "../src/common/rfkill.vala"
		case RF_KILL_OPERATION_ADD:
#line 838 "rfkill.c"
		{
			RFKillDevice* device = NULL;
			RFKillEvent _tmp1_;
			RFKillEvent _tmp2_;
			RFKillEvent _tmp3_;
			RFKillEvent _tmp4_;
			RFKillDevice* _tmp5_;
			RFKillDevice* _tmp6_;
			RFKillDevice* _tmp7_;
			RFKillDevice* _tmp8_;
#line 102 "../src/common/rfkill.vala"
			_tmp1_ = event;
#line 102 "../src/common/rfkill.vala"
			_tmp2_ = event;
#line 102 "../src/common/rfkill.vala"
			_tmp3_ = event;
#line 102 "../src/common/rfkill.vala"
			_tmp4_ = event;
#line 102 "../src/common/rfkill.vala"
			_tmp5_ = rf_kill_device_new (self, _tmp1_.idx, (RFKillDeviceType) _tmp2_.type, ((gint) _tmp3_.soft) != 0, ((gint) _tmp4_.hard) != 0);
#line 102 "../src/common/rfkill.vala"
			device = _tmp5_;
#line 103 "../src/common/rfkill.vala"
			_tmp6_ = device;
#line 103 "../src/common/rfkill.vala"
			_tmp7_ = _rf_kill_device_ref0 (_tmp6_);
#line 103 "../src/common/rfkill.vala"
			self->priv->_devices = g_list_append (self->priv->_devices, _tmp7_);
#line 104 "../src/common/rfkill.vala"
			_tmp8_ = device;
#line 104 "../src/common/rfkill.vala"
			g_signal_emit (self, rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_ADDED_SIGNAL], 0, _tmp8_);
#line 105 "../src/common/rfkill.vala"
			_rf_kill_device_unref0 (device);
#line 105 "../src/common/rfkill.vala"
			break;
#line 875 "rfkill.c"
		}
#line 100 "../src/common/rfkill.vala"
		case RF_KILL_OPERATION_DELETE:
#line 879 "rfkill.c"
		{
			RFKillDevice* device = NULL;
			RFKillEvent _tmp9_;
			RFKillDevice* _tmp10_;
			RFKillDevice* _tmp11_;
#line 107 "../src/common/rfkill.vala"
			_tmp9_ = event;
#line 107 "../src/common/rfkill.vala"
			_tmp10_ = rf_kill_manager_get_device (self, _tmp9_.idx);
#line 107 "../src/common/rfkill.vala"
			device = _tmp10_;
#line 108 "../src/common/rfkill.vala"
			_tmp11_ = device;
#line 108 "../src/common/rfkill.vala"
			if (_tmp11_ != NULL) {
#line 895 "rfkill.c"
				RFKillDevice* _tmp12_;
				RFKillDevice* _tmp13_;
#line 109 "../src/common/rfkill.vala"
				_tmp12_ = device;
#line 109 "../src/common/rfkill.vala"
				self->priv->_devices = g_list_remove (self->priv->_devices, _tmp12_);
#line 110 "../src/common/rfkill.vala"
				_tmp13_ = device;
#line 110 "../src/common/rfkill.vala"
				g_signal_emit (self, rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_DELETED_SIGNAL], 0, _tmp13_);
#line 906 "rfkill.c"
			}
#line 112 "../src/common/rfkill.vala"
			_rf_kill_device_unref0 (device);
#line 112 "../src/common/rfkill.vala"
			break;
#line 912 "rfkill.c"
		}
#line 100 "../src/common/rfkill.vala"
		case RF_KILL_OPERATION_CHANGE:
#line 916 "rfkill.c"
		{
			RFKillDevice* device = NULL;
			RFKillEvent _tmp14_;
			RFKillDevice* _tmp15_;
			RFKillDevice* _tmp16_;
#line 114 "../src/common/rfkill.vala"
			_tmp14_ = event;
#line 114 "../src/common/rfkill.vala"
			_tmp15_ = rf_kill_manager_get_device (self, _tmp14_.idx);
#line 114 "../src/common/rfkill.vala"
			device = _tmp15_;
#line 115 "../src/common/rfkill.vala"
			_tmp16_ = device;
#line 115 "../src/common/rfkill.vala"
			if (_tmp16_ != NULL) {
#line 932 "rfkill.c"
				RFKillDevice* _tmp17_;
				RFKillEvent _tmp18_;
				RFKillDevice* _tmp19_;
				RFKillEvent _tmp20_;
				RFKillDevice* _tmp21_;
				RFKillDevice* _tmp22_;
#line 116 "../src/common/rfkill.vala"
				_tmp17_ = device;
#line 116 "../src/common/rfkill.vala"
				_tmp18_ = event;
#line 116 "../src/common/rfkill.vala"
				_tmp17_->_software_lock = ((gint) _tmp18_.soft) != 0;
#line 117 "../src/common/rfkill.vala"
				_tmp19_ = device;
#line 117 "../src/common/rfkill.vala"
				_tmp20_ = event;
#line 117 "../src/common/rfkill.vala"
				_tmp19_->_hardware_lock = ((gint) _tmp20_.hard) != 0;
#line 118 "../src/common/rfkill.vala"
				_tmp21_ = device;
#line 118 "../src/common/rfkill.vala"
				g_signal_emit (_tmp21_, rf_kill_device_signals[RF_KILL_DEVICE_CHANGED_SIGNAL], 0);
#line 119 "../src/common/rfkill.vala"
				_tmp22_ = device;
#line 119 "../src/common/rfkill.vala"
				g_signal_emit (self, rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_CHANGED_SIGNAL], 0, _tmp22_);
#line 959 "rfkill.c"
			}
#line 121 "../src/common/rfkill.vala"
			_rf_kill_device_unref0 (device);
#line 121 "../src/common/rfkill.vala"
			break;
#line 965 "rfkill.c"
		}
		default:
#line 100 "../src/common/rfkill.vala"
		break;
#line 970 "rfkill.c"
	}
#line 123 "../src/common/rfkill.vala"
	result = TRUE;
#line 123 "../src/common/rfkill.vala"
	return result;
#line 976 "rfkill.c"
}

static RFKillDevice*
rf_kill_manager_get_device (RFKillManager* self,
                            guint32 idx)
{
	RFKillDevice* result = NULL;
	GList* _tmp0_;
#line 126 "../src/common/rfkill.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../src/common/rfkill.vala"
	_tmp0_ = self->priv->_devices;
#line 989 "rfkill.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 127 "../src/common/rfkill.vala"
		device_collection = _tmp0_;
#line 127 "../src/common/rfkill.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 997 "rfkill.c"
			RFKillDevice* _tmp1_;
			RFKillDevice* device = NULL;
#line 127 "../src/common/rfkill.vala"
			_tmp1_ = _rf_kill_device_ref0 ((RFKillDevice*) device_it->data);
#line 127 "../src/common/rfkill.vala"
			device = _tmp1_;
#line 1004 "rfkill.c"
			{
				RFKillDevice* _tmp2_;
#line 128 "../src/common/rfkill.vala"
				_tmp2_ = device;
#line 128 "../src/common/rfkill.vala"
				if (_tmp2_->idx == idx) {
#line 129 "../src/common/rfkill.vala"
					result = device;
#line 129 "../src/common/rfkill.vala"
					return result;
#line 1015 "rfkill.c"
				}
#line 127 "../src/common/rfkill.vala"
				_rf_kill_device_unref0 (device);
#line 1019 "rfkill.c"
			}
		}
	}
#line 132 "../src/common/rfkill.vala"
	result = NULL;
#line 132 "../src/common/rfkill.vala"
	return result;
#line 1027 "rfkill.c"
}

static void
g_cclosure_user_marshal_VOID__RF_KILL_DEVICE (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__RF_KILL_DEVICE) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__RF_KILL_DEVICE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 55 "../src/common/rfkill.vala"
	g_return_if_fail (n_param_values == 2);
#line 55 "../src/common/rfkill.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 55 "../src/common/rfkill.vala"
		data1 = closure->data;
#line 55 "../src/common/rfkill.vala"
		data2 = param_values->data[0].v_pointer;
#line 1052 "rfkill.c"
	} else {
#line 55 "../src/common/rfkill.vala"
		data1 = param_values->data[0].v_pointer;
#line 55 "../src/common/rfkill.vala"
		data2 = closure->data;
#line 1058 "rfkill.c"
	}
#line 55 "../src/common/rfkill.vala"
	callback = (GMarshalFunc_VOID__RF_KILL_DEVICE) (marshal_data ? marshal_data : cc->callback);
#line 55 "../src/common/rfkill.vala"
	callback (data1, value_get_rf_kill_device (param_values + 1), data2);
#line 1064 "rfkill.c"
}

static void
rf_kill_manager_class_init (RFKillManagerClass * klass,
                            gpointer klass_data)
{
#line 55 "../src/common/rfkill.vala"
	rf_kill_manager_parent_class = g_type_class_peek_parent (klass);
#line 55 "../src/common/rfkill.vala"
	g_type_class_adjust_private_offset (klass, &RFKillManager_private_offset);
#line 55 "../src/common/rfkill.vala"
	G_OBJECT_CLASS (klass)->finalize = rf_kill_manager_finalize;
#line 55 "../src/common/rfkill.vala"
	rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", TYPE_RF_KILL_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__RF_KILL_DEVICE, G_TYPE_NONE, 1, TYPE_RF_KILL_DEVICE);
#line 55 "../src/common/rfkill.vala"
	rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_CHANGED_SIGNAL] = g_signal_new ("device-changed", TYPE_RF_KILL_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__RF_KILL_DEVICE, G_TYPE_NONE, 1, TYPE_RF_KILL_DEVICE);
#line 55 "../src/common/rfkill.vala"
	rf_kill_manager_signals[RF_KILL_MANAGER_DEVICE_DELETED_SIGNAL] = g_signal_new ("device-deleted", TYPE_RF_KILL_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__RF_KILL_DEVICE, G_TYPE_NONE, 1, TYPE_RF_KILL_DEVICE);
#line 1083 "rfkill.c"
}

static void
rf_kill_manager_instance_init (RFKillManager * self,
                               gpointer klass)
{
#line 55 "../src/common/rfkill.vala"
	self->priv = rf_kill_manager_get_instance_private (self);
#line 92 "../src/common/rfkill.vala"
	self->fd = -1;
#line 1094 "rfkill.c"
}

static void
rf_kill_manager_finalize (GObject * obj)
{
	RFKillManager * self;
#line 55 "../src/common/rfkill.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RF_KILL_MANAGER, RFKillManager);
#line 93 "../src/common/rfkill.vala"
	(self->priv->_devices == NULL) ? NULL : (self->priv->_devices = (_g_list_free__rf_kill_device_unref0_ (self->priv->_devices), NULL));
#line 55 "../src/common/rfkill.vala"
	G_OBJECT_CLASS (rf_kill_manager_parent_class)->finalize (obj);
#line 1107 "rfkill.c"
}

GType
rf_kill_manager_get_type (void)
{
	static volatile gsize rf_kill_manager_type_id__volatile = 0;
	if (g_once_init_enter (&rf_kill_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RFKillManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rf_kill_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RFKillManager), 0, (GInstanceInitFunc) rf_kill_manager_instance_init, NULL };
		GType rf_kill_manager_type_id;
		rf_kill_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "RFKillManager", &g_define_type_info, 0);
		RFKillManager_private_offset = g_type_add_instance_private (rf_kill_manager_type_id, sizeof (RFKillManagerPrivate));
		g_once_init_leave (&rf_kill_manager_type_id__volatile, rf_kill_manager_type_id);
	}
	return rf_kill_manager_type_id__volatile;
}

RFKillEvent*
rf_kill_event_dup (const RFKillEvent* self)
{
	RFKillEvent* dup;
#line 136 "../src/common/rfkill.vala"
	dup = g_new0 (RFKillEvent, 1);
#line 136 "../src/common/rfkill.vala"
	memcpy (dup, self, sizeof (RFKillEvent));
#line 136 "../src/common/rfkill.vala"
	return dup;
#line 1134 "rfkill.c"
}

void
rf_kill_event_free (RFKillEvent* self)
{
#line 136 "../src/common/rfkill.vala"
	g_free (self);
#line 1142 "rfkill.c"
}

GType
rf_kill_event_get_type (void)
{
	static volatile gsize rf_kill_event_type_id__volatile = 0;
	if (g_once_init_enter (&rf_kill_event_type_id__volatile)) {
		GType rf_kill_event_type_id;
		rf_kill_event_type_id = g_boxed_type_register_static ("RFKillEvent", (GBoxedCopyFunc) rf_kill_event_dup, (GBoxedFreeFunc) rf_kill_event_free);
		g_once_init_leave (&rf_kill_event_type_id__volatile, rf_kill_event_type_id);
	}
	return rf_kill_event_type_id__volatile;
}

GType
rf_kill_operation_get_type (void)
{
	static volatile gsize rf_kill_operation_type_id__volatile = 0;
	if (g_once_init_enter (&rf_kill_operation_type_id__volatile)) {
		static const GEnumValue values[] = {{RF_KILL_OPERATION_ADD, "RF_KILL_OPERATION_ADD", "add"}, {RF_KILL_OPERATION_DELETE, "RF_KILL_OPERATION_DELETE", "delete"}, {RF_KILL_OPERATION_CHANGE, "RF_KILL_OPERATION_CHANGE", "change"}, {RF_KILL_OPERATION_CHANGE_ALL, "RF_KILL_OPERATION_CHANGE_ALL", "change-all"}, {0, NULL, NULL}};
		GType rf_kill_operation_type_id;
		rf_kill_operation_type_id = g_enum_register_static ("RFKillOperation", values);
		g_once_init_leave (&rf_kill_operation_type_id__volatile, rf_kill_operation_type_id);
	}
	return rf_kill_operation_type_id__volatile;
}

